package ovh.herisson.thevoidroad.Entity;

import java.util.Random;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.entity.Villager;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.world.EntitiesUnloadEvent;

import ovh.herisson.thevoidroad.Event.HourEvent;

//Unique, so singleton patern
public class Merchand implements Listener{
	private static Merchand instance;

	public static Merchand getInstance(){
		if(instance != null)
			return instance;
		return new Merchand();
	}

	private Villager m ;
	private Merchand() {
		generate();
	}

	private void generate(){
		int x = new Random().nextInt(750 * 2) - 750, z = new Random().nextInt(750 * 2) - 750;
		m = (Villager) Bukkit.getWorld("world").spawnEntity(new Location(Bukkit.getWorld("world"), x, 300, z), EntityType.VILLAGER);
		m.setGlowing(true);
		m.setInvulnerable(true);
		Bukkit.getServer().forEachAudience((a) -> {
			if(a instanceof Player ply){
				ply.setCompassTarget(m.getLocation());
			}
		}); //Temporary
	}

	public void regenerate(){
		if(m != null){ m.remove(); }
		generate();
	}

	@EventHandler
	public void onHour(HourEvent e){
		regenerate();
	}

	@EventHandler //TODO(Merchand): Check if can't do using ticket chunk
	public void onUnload(EntitiesUnloadEvent e){
		if(e.getEntities().contains(m)){
			m.getChunk().load();
		}
	}

}
