package ovh.herisson.thevoidroad;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

public final class Voids{	

	private Voids(){} // Prohib the instantiation 

	public static int get(Player ply){
		try {
			return TheVoidRoad.db.getVoids(ply.getUniqueId());
		} catch(SQLException e){
			e.printStackTrace();
		}
		return 0;
	}

	public static void set(Player ply, int amount){
		try {
			TheVoidRoad.db.setVoids(ply.getUniqueId(), amount);

		} catch(SQLException e){
			e.printStackTrace();
		}
	}

	public static void add(Player ply, int amount){
		try {
			int curr = TheVoidRoad.db.getVoids(ply.getUniqueId());
			TheVoidRoad.db.setVoids(ply.getUniqueId(), curr + amount);
		} catch(SQLException e){
			e.printStackTrace();
		}
	} 
	
	public static boolean subtract(Player ply, int amount, boolean force){
		try {
			int curr = TheVoidRoad.db.getVoids(ply.getUniqueId());
			if(curr - amount < 0 && !force) return false;
			TheVoidRoad.db.setVoids(ply.getUniqueId(), curr - amount);
		} catch(SQLException e){
			e.printStackTrace();
		}
		return true;
	} 

	public static boolean give(Player giver, Player receiver, int amount){
		if(subtract(giver, amount, false)){
			add(receiver, amount);
			return true;
		}
		return false;
	}

	public static HashMap<Player, Integer> scoreboard(){
		HashMap<Player, Integer> ret = new HashMap<>();
		try {
			HashMap<UUID, Integer> scores_uuid = TheVoidRoad.db.getVoidsScoreboard();
			scores_uuid.forEach((u, a) -> {
				ret.put(Bukkit.getPlayer(u), a);
			});
		} catch(SQLException e){
			e.printStackTrace();
		}
		return ret;
	}
}
